/* test the creation of Java arrays, ---rgf, 2003-02-17 */

if rxFuncQuery("BSF") then  /* no bsf4rexx support available yet, hence load Java */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs    /* load all BSF-functions                    */
   call BsfLoadJava     /* load the JVM and set up BSF4Rexx-support  */
end

   /* define the class objects (pre-registered by bsf4rexx) to test */
classes= 'Class.class' 'Object.class' 'Method.class' 'String.class' 'Array.class'    ,
         'boolean.class' 'Boolean.class' 'byte.class' 'Byte.class' 'char.class'      ,
         'Character.class' 'double.class' 'Double.class' 'float.class' 'Float.class' ,
         'int.class' 'Integer.class' 'long.class' 'Long.class' 'short.class'         ,
         'Short.class'

all=words(classes)   /* determine number of class objects   */
say "There are" all "class objects to test:"
say
crlf="0d0a"x
do i=1 to all
   dim=random(1,7)   /* number of dimensions */
   intArr=bsf('createArray', 'int.class', dim)  /* create an int-array  */
   dimString=""
   count=1
   do dimIdx=0 to dim-1    /* loop over dimenstions                           */
      nr=random(1,3)       /* determine number of elements in this dimension  */
      count=count*nr
      dimString=dimString || choose(dimIdx=0, "", ", ") || nr
      call bsf 'arrayPut', intArr, "int", nr, dimIdx   /* define number of entries for this dimension */
   end

   arr=bsf('createArray', word(classes, i), intArr)/* now create the array */
   arrWrap=bsf('wrapArray', arr)                   /* wrap the array       */
   say "Created an array of type ["word(classes,i)"] dimensions=("||dimString")"
   say "        beanName="||arr

   say "      dimensions="||bsf('getFieldValue', arrWrap, "dimensions") "(# of dimensions="||dim")"
   say "           items="||bsf('getFieldValue', arrWrap, "items") "(count="count")"

   call bsf "unregisterBean", arrWrap        /* unregister bean   */
   call bsf "unregisterBean", arr            /* unregister bean   */
   call bsf "unregisterBean", intArr         /* unregister bean   */

   say copies("-", 50)
end
say "finished."
exit


choose: procedure /* Rexx-style of C/Java: "test ? then-value : else-value" */
  if arg(1)=1 then return arg(2)
              else return arg(3)


